fsstress: translate flags in fiemap_f
[xfstests-dev.git] / check
diff --git a/check b/check
index 71993f75862a906cccc27508684fc4875485afcc..b619f6db2b2687f578d3e0c2edb323088dade96d 100755 (executable)
--- a/check
+++ b/check
@@ -28,47 +28,56 @@ n_bad=0
 bad=""
 notrun=""
 interrupt=true
+diff="diff -u"
+showme=false
+have_test_arg=false
+randomize=false
+export here=`pwd`
+xfile=""
 
+# start the initialisation work now
+iam=check
+
+export MSGVERB="text:action"
 export QA_CHECK_FS=${QA_CHECK_FS:=true}
+
 # number of diff lines from a failed test, 0 for whole output
 export DIFF_LENGTH=${DIFF_LENGTH:=10}
 
 # by default don't output timestamps
 timestamp=${TIMESTAMP:=false}
 
-# generic initialization
-iam=check
+rm -f $tmp.list $tmp.tmp $tmp.grep $here/$iam.out $tmp.xlist
 
-# we need common.config
-if ! . ./common.config
+# we need common/config
+if ! . ./common/config
 then
-    echo "$iam: failed to source common.config"
+    echo "$iam: failed to source common/config"
     exit 1
 fi
 
-# argument parsing first - currently very messy, needs cleanup.
-_setenvironment()
-{
-    MSGVERB="text:action"
-    export MSGVERB
-}
+# Autodetect fs type based on what's on $TEST_DEV unless it's been set
+# externally
+if [ -z "$FSTYP" -a "$HOSTOS" == "Linux" ]; then
+    FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
+fi
+FSTYP=${FSTYP:=xfs}
+export FSTYP
+
+SUPPORTED_TESTS="[0-9][0-9][0-9] [0-9][0-9][0-9][0-9]"
+SRC_GROUPS="generic shared"
+export SRC_DIR="tests"
 
 usage()
 {
     echo "Usage: $0 [options] [testlist]"'
 
-common options
-    -v                 verbose
-
 check options
-    -xfs                test XFS (default)
-    -udf                test UDF
     -nfs                test NFS
+    -tmpfs              test TMPFS
     -l                 line mode diff
-    -xdiff             graphical mode diff
     -udiff             show unified diff (default)
     -n                 show me, do not run tests
-    -q                 quick [deprecated]
     -T                 output timestamps
     -r                 randomize test order
     --large-fs         optimise scratch device for large filesystems
@@ -76,293 +85,208 @@ check options
 testlist options
     -g group[,group...]        include tests from these groups
     -x group[,group...]        exclude tests from these groups
-    NNN                        include test NNN
-    NNN-NNN            include test range (eg. 012-021)
+    -X file            exclude individual tests
+    [testlist]         include tests matching names in testlist
 '
            exit 0
 }
 
-here=`pwd`
-rm -f $here/$iam.out
-_setenvironment
-
-check=${check-true}
-
-diff="diff -u"
-verbose=false
-group=false
-xgroup=false
-showme=false
-sortme=false
-expunge=true
-have_test_arg=false
-randomize=false
-rm -f $tmp.list $tmp.tmp $tmp.sed
-
-# Autodetect fs type based on what's on $TEST_DEV
-if [ "$HOSTOS" == "Linux" ]
-then
-    export FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
-else
-    export FSTYP=xfs
-fi
-
-for r
-do
+get_group_list()
+{
+       grp=$1
+
+       for d in $SRC_GROUPS $FSTYP; do
+               l=$(sed -n < $SRC_DIR/$d/group \
+                       -e 's/#.*//' \
+                       -e 's/$/ /' \
+                       -e "s;\(^[0-9][0-9][0-9]\).* $grp .*;$SRC_DIR/$d/\1;p")
+               grpl="$grpl $l"
+       done
+       echo $grpl
+}
 
-    if $group
-    then
-       # arg after -g
-       group_list=$(sed -n < group \
-                       -e 's/#.*//' \
-                       -e 's/$/ /' \
-                       -e "/^[0-9][0-9][0-9].* $r /"'{ s/ .*//p }')
-       if [ -z "$group_list" ]
-       then
-           echo "Group \"$r\" is empty or not defined?"
-           exit 1
-       fi
-       [ ! -s $tmp.list ] && touch $tmp.list
-       for t in $group_list
-       do
-           if grep -s "^$t\$" $tmp.list >/dev/null
-           then
-               :
-           else
-               echo "$t" >>$tmp.list
-           fi
+# find all tests, excluding files that are test metadata such as group files.
+# This assumes that tests are defined purely by alphanumeric filenames with no
+# ".xyz" extensions in the name.
+get_all_tests()
+{
+       touch $tmp.list
+       for d in $SRC_GROUPS $FSTYP; do
+               ls $SRC_DIR/$d/* | \
+                       grep -v "\..*" | \
+                       grep -v "group\|Makefile" >> $tmp.list 2>/dev/null
        done
-       group=false
-       continue
+}
 
-    elif $xgroup
-    then
-       # arg after -x
-       [ ! -s $tmp.list ] && ls [0-9][0-9][0-9] [0-9][0-9][0-9][0-9] >$tmp.list 2>/dev/null
-       group_list=`sed -n <group -e 's/$/ /' -e "/^[0-9][0-9][0-9].* $r /"'{
-s/ .*//p
-}'`
-       if [ -z "$group_list" ]
-       then
-           echo "Group \"$r\" is empty or not defined?"
-           exit 1
-       fi
+# takes the list of tests to run in $tmp.list, and removes the tests passed to
+# the function from that list.
+trim_test_list()
+{
+       test_list="$*"
+
+       rm -f $tmp.grep
        numsed=0
-       rm -f $tmp.sed
-       for t in $group_list
+       for t in $test_list
        do
-           if [ $numsed -gt 100 ]
-           then
-               sed -f $tmp.sed <$tmp.list >$tmp.tmp
+           if [ $numsed -gt 100 ]; then
+               grep -v -f $tmp.grep <$tmp.list >$tmp.tmp
                mv $tmp.tmp $tmp.list
                numsed=0
-               rm -f $tmp.sed
+               rm -f $tmp.grep
            fi
-           echo "/^$t\$/d" >>$tmp.sed
+           echo "^$t\$" >>$tmp.grep
            numsed=`expr $numsed + 1`
        done
-       sed -f $tmp.sed <$tmp.list >$tmp.tmp
+       grep -v -f $tmp.grep <$tmp.list >$tmp.tmp
        mv $tmp.tmp $tmp.list
-       xgroup=false
-       continue
-    fi
+}
 
-    xpand=true
-    case "$r"
-    in
 
-       -\? | -h | --help)      # usage
-           usage
-           ;;
+_wallclock()
+{
+    date "+%H %M %S" | $AWK_PROG '{ print $1*3600 + $2*60 + $3 }'
+}
 
-       -udf)   # -udf ... set FSTYP to udf
-           FSTYP=udf
-           xpand=false
-           ;;
+_timestamp()
+{
+    now=`date "+%T"`
+    echo -n " [$now]"
+}
 
-       -xfs)   # -xfs ... set FSTYP to xfs
-           FSTYP=xfs
-           xpand=false
-           ;;
+_prepare_test_list()
+{
+       unset list
+       # Tests specified on the command line
+       if [ -s $tmp.arglist ]; then
+               cat $tmp.arglist > $tmp.list
+       else
+               touch $tmp.list
+       fi
 
-       -nfs)   # -nfs ... set FSTYP to nfs
-           FSTYP=nfs
-           xpand=false
-           ;;
+       # Specified groups to include
+       for group in $GROUP_LIST; do
+               list=$(get_group_list $group)
+               if [ -z "$list" ]; then
+                       echo "Group \"$group\" is empty or not defined?"
+                       exit 1
+               fi
 
-       -g)     # -g group ... pick from group file
-           group=true
-           xpand=false
-           ;;
+               for t in $list; do
+                       grep -s "^$t\$" $tmp.list >/dev/null || \
+                                                       echo "$t" >>$tmp.list
+               done
+       done
 
-       -l)     # line mode for diff, was default before
-           diff="diff"
-           xpand=false
-           ;;
+       if ! $have_test_arg && [ -z "$GROUP_LIST" ]; then
+               # no test numbers, do everything
+               get_all_tests
+       fi
 
-       -xdiff) # graphical diff mode
-           xpand=false
+       # Specified groups to exclude
+       for xgroup in $XGROUP_LIST; do
+               list=$(get_group_list $xgroup)
+               if [ -z "$list" ]; then
+                       echo "Group \"$xgroup\" is empty or not defined?"
+                       exit 1
+               fi
 
-           if [ ! -z "$DISPLAY" ]
-           then
-               which xdiff >/dev/null 2>&1 && diff=xdiff
-               which gdiff >/dev/null 2>&1 && diff=gdiff
-               which tkdiff >/dev/null 2>&1 && diff=tkdiff
-               which xxdiff >/dev/null 2>&1 && diff=xxdiff
-           fi
-           ;;
-
-       -udiff) # show a unified diff, default now, keep for backward compat
-           xpand=false
-           diff="$diff -u"
-           ;;
-
-       -q)     # "quick", no longer used - always quick :-)
-           xpand=false
-           ;;
-
-       -n)     # show me, don't do it
-           showme=true
-           xpand=false
-           ;;
-        -r)    # randomize test order
-           randomize=true
-           xpand=false
-           ;;
-
-       -T)     # turn on timestamp output
-           timestamp=true
-           xpand=false
-           ;;
-
-       -v)
-           verbose=true
-           xpand=false
-           ;;
-       -x)     # -x group ... exclude from group file
-           xgroup=true
-           xpand=false
-           ;;
-       '[0-9][0-9][0-9] [0-9][0-9][0-9][0-9]')
-           echo "No tests?"
-           status=1
-           exit $status
-           ;;
-
-       [0-9]*-[0-9]*)
-           eval `echo $r | sed -e 's/^/start=/' -e 's/-/ end=/'`
-           ;;
-
-       [0-9]*-)
-           eval `echo $r | sed -e 's/^/start=/' -e 's/-//'`
-           end=`echo [0-9][0-9][0-9] [0-9][0-9][0-9][0-9] | sed -e 's/\[0-9]//g' -e 's/  *$//' -e 's/.* //'`
-           if [ -z "$end" ]
-           then
-               echo "No tests in range \"$r\"?"
-               status=1
-               exit $status
-           fi
-           ;;
+               trim_test_list $list
+       done
 
-       --large-fs)
-           export LARGE_SCRATCH_DEV=yes
-           xpand=false
-           ;;
+       # sort the list of tests into numeric order
+       list=`sort -n $tmp.list | uniq`
+       rm -f $tmp.list $tmp.tmp $tmp.grep
 
-       -*)
-           usage
-           ;;
+       if $randomize
+       then
+               list=`echo $list | awk -f randomize.awk`
+       fi
+}
 
-       --extra-space=*)
-           export SCRATCH_DEV_EMPTY_SPACE=${r#*=}
-           xpand=false
-           ;;
+# Process command arguments first.
+while [ $# -gt 0 ]; do
+       case "$1" in
+       -\? | -h | --help) usage ;;
 
-       *)
-           start=$r
-           end=$r
-           ;;
+       -nfs)   FSTYP=nfs ;;
+       -tmpfs) FSTYP=tmpfs ;;
 
-    esac
+       -g)     group=$2 ; shift ;
+               GROUP_LIST="$GROUP_LIST $group"
+               ;;
 
-    # get rid of leading 0s as can be interpreted as octal
-    start=`echo $start | sed 's/^0*//'`
-    end=`echo $end | sed 's/^0*//'`
+       -x)     xgroup=$2 ; shift ;
+               XGROUP_LIST="$XGROUP_LIST $xgroup"
+               ;;
 
-    if $xpand
-    then
-       have_test_arg=true
-       $AWK_PROG </dev/null '
-BEGIN  { for (t='$start'; t<='$end'; t++) printf "%03d\n",t }' \
-       | while read id
-       do
-           if grep -s "^$id " group >/dev/null
-           then
-               # in group file ... OK
-               echo $id >>$tmp.list
-           else
-               if [ -f expunged ] && $expunge && egrep "^$id([         ]|\$)" expunged >/dev/null
-               then
-                   # expunged ... will be reported, but not run, later
-                   echo $id >>$tmp.list
-               else
-                   # oops
-                   echo "$id - unknown test, ignored"
-               fi
-           fi
-       done
-    fi
+       -X)     xfile=$2; shift ;
+               for d in $SRC_GROUPS $FSTYP; do
+                       [ -f $SRC_DIR/$d/$xfile ] || continue
+                       for f in `cat $SRC_DIR/$d/$xfile`; do
+                               echo $d/$f >> $tmp.xlist
+                       done
+               done
+               ;;
 
-done
+       -l)     diff="diff" ;;
+       -udiff) diff="$diff -u" ;;
 
-if [ -s $tmp.list ]
-then
-    # found some valid test numbers ... this is good
-    :
-else
-    if $have_test_arg
-    then
-       # had test numbers, but none in group file ... do nothing
-       touch $tmp.list
-    else
-       # no test numbers, do everything from group file
-       sed -n -e '/^[0-9][0-9][0-9]*/s/[       ].*//p' <group >$tmp.list
-    fi
-fi
+       -n)     showme=true ;;
+        -r)    randomize=true ;;
 
-# should be sort -n, but this did not work for Linux when this
-# was ported from IRIX
-#
-list=`sort $tmp.list`
-rm -f $tmp.list $tmp.tmp $tmp.sed
+       -T)     timestamp=true ;;
 
-if $randomize
-then
-    list=`echo $list | awk -f randomize.awk`
+       --large-fs) export LARGE_SCRATCH_DEV=yes ;;
+       --extra-space=*) export SCRATCH_DEV_EMPTY_SPACE=${r#*=} ;;
+
+       -*)     usage ;;
+       *)      # not an argument, we've got tests now.
+               have_test_arg=true ;;
+       esac
+
+       # if we've found a test specification, the break out of the processing
+       # loop before we shift the arguments so that this is the first argument
+       # that we process in the test arg loop below.
+       if $have_test_arg; then
+               break;
+       fi
+
+       shift
+done
+
+# Process tests from command line now.
+if $have_test_arg; then
+       while [ $# -gt 0 ]; do
+               case "$1" in
+               -*)     echo "Argments before tests, please!"
+                       status=1
+                       exit $status
+                       ;;
+               *)      test_dir=`dirname $1`
+                       test_dir=${test_dir#$SRC_DIR/*}
+                       test_name=`basename $1`
+                       group_file=$SRC_DIR/$test_dir/group
+
+                       if egrep "^$test_name" $group_file >/dev/null ; then
+                               # in group file ... OK
+                               echo $SRC_DIR/$test_dir/$test_name >>$tmp.arglist
+                       else
+                               # oops
+                               echo "$1 - unknown test, ignored"
+                       fi
+                       ;;
+               esac
+
+               shift
+       done
 fi
 
-case "$FSTYP" in
-    xfs)
-        [ "$XFS_LOGPRINT_PROG" = "" ] && _fatal "xfs_logprint not found"
-        [ "$XFS_REPAIR_PROG" = "" ] && _fatal "xfs_repair not found"
-        [ "$XFS_CHECK_PROG" = "" ] && _fatal "xfs_check not found"
-        [ "$XFS_DB_PROG" = "" ] && _fatal "xfs_db not found"
-        [ "$MKFS_XFS_PROG" = "" ] && _fatal "mkfs_xfs not found"
-        ;;
-    udf)
-        [ "$MKFS_UDF_PROG" = "" ] && _fatal "mkfs_udf/mkudffs not found"
-        ;;
-    btrfs)
-        [ "$MKFS_BTRFS_PROG" = "" ] && _fatal "mkfs.btrfs not found"
-        ;;
-    nfs)
-        ;;
-esac
-
-# we need common.rc
-if ! . ./common.rc
+_prepare_test_list
+
+# we need common/rc
+if ! . ./common/rc
 then
-    echo "check: failed to source common.rc"
+    echo "check: failed to source common/rc"
     exit 1
 fi
 
@@ -372,33 +296,21 @@ then
     exit 1
 fi
 
-_wallclock()
-{
-    date "+%H %M %S" | $AWK_PROG '{ print $1*3600 + $2*60 + $3 }'
-}
-
-_timestamp()
-{
-    now=`date "+%T"`
-    echo -n " [$now]"
-}
+# Ok, time to start running...
 
 _wrapup()
 {
-    # for hangcheck ...
-    # remove files that were used by hangcheck
-    #
-    [ -f /tmp/check.pid ] && rm -rf /tmp/check.pid
-    [ -f /tmp/check.sts ] && rm -rf /tmp/check.sts
+    seq="check"
+    check="$RESULT_BASE/check"
 
     if $showme
     then
        :
     elif $needwrap
     then
-       if [ -f check.time -a -f $tmp.time ]
+       if [ -f $check.time -a -f $tmp.time ]
        then
-           cat check.time $tmp.time \
+           cat $check.time $tmp.time \
            | $AWK_PROG '
        { t[$1] = $2 }
 END    { if (NR > 0) {
@@ -406,20 +318,13 @@ END       { if (NR > 0) {
          }
        }' \
            | sort -n >$tmp.out
-           mv $tmp.out check.time
-       fi
-
-       if [ -f $tmp.expunged ]
-       then
-           notrun=`wc -l <$tmp.expunged | sed -e 's/  *//g'`
-           n_try=`expr $n_try - $notrun`
-           list=`echo "$list" | sed -f $tmp.expunged`
+           mv $tmp.out $check.time
        fi
 
-       echo "" >>check.log
-       date >>check.log
-       echo $list | fmt | sed -e 's/^/    /' >>check.log
-       $interrupt && echo "Interrupted!" >>check.log
+       echo "" >>$check.log
+       date >>$check.log
+       echo $list | fmt | sed -e 's/^/    /' -e "s;$SRC_DIR/;;g" >>$check.log
+       $interrupt && echo "Interrupted!" >>$check.log
         
         if [ ! -z "$n_try" -a $n_try != 0 ]
        then
@@ -429,48 +334,41 @@ END       { if (NR > 0) {
        if [ ! -z "$notrun" ]
        then
            echo "Not run:$notrun"
-           echo "Not run:$notrun" >>check.log
+           echo "Not run:$notrun" >>$check.log
        fi
 
         if [ ! -z "$n_bad" -a $n_bad != 0 ]
        then
            echo "Failures:$bad"
            echo "Failed $n_bad of $n_try tests"
-           echo "Failures:$bad" | fmt >>check.log
-           echo "Failed $n_bad of $n_try tests" >>check.log
+           echo "Failures:$bad" | fmt >>$check.log
+           echo "Failed $n_bad of $n_try tests" >>$check.log
        else
            echo "Passed all $n_try tests"
-           echo "Passed all $n_try tests" >>check.log
+           echo "Passed all $n_try tests" >>$check.log
        fi
        needwrap=false
     fi
 
     rm -f /tmp/*.rawout /tmp/*.out /tmp/*.err /tmp/*.time
-    rm -f /tmp/check.pid /tmp/check.sts
     rm -f $tmp.*
 }
 
 trap "_wrapup; exit \$status" 0 1 2 3 15
 
-# for hangcheck ...
-# Save pid of check in a well known place, so that hangcheck can be sure it
-# has the right pid (getting the pid from ps output is not reliable enough).
-#
-rm -rf /tmp/check.pid
-echo $$ >/tmp/check.pid
+mkdir -p $RESULT_BASE
+if [ ! -d $RESULT_BASE ]; then
+       echo "failed to create results directory $RESULTS_BASE"
+       exit 1;
+fi
 
-# for hangcheck ...
-# Save the status of check in a well known place, so that hangcheck can be
-# sure to know where check is up to (getting test number from ps output is
-# not reliable enough since the trace stuff has been introduced).
-#
-rm -rf /tmp/check.sts
-echo "preamble" >/tmp/check.sts
+seq="check"
+check="$RESULT_BASE/check"
 
 # don't leave old full output behind on a clean run
-rm -f check.full
+rm -f $check.full
 
-[ -f check.time ] || touch check.time
+[ -f $check.time ] || touch $check.time
 
 # print out our test configuration
 echo "FSTYP         -- `_full_fstyp_details`"
@@ -506,53 +404,59 @@ if [ ! -z "$SCRATCH_DEV" ]; then
   fi
 fi
 
-seq="check"
+seqres="$check"
 _check_test_fs
 
-[ -n "$TESTS_REMAINING_LOG" ] && echo $list > $TESTS_REMAINING_LOG
-
 for seq in $list
 do
     err=false
-    echo -n "$seq"
-    if [ -n "$TESTS_REMAINING_LOG" ] ; then
-        sed -e "s/$seq//" -e 's/  / /' -e 's/^ *//' $TESTS_REMAINING_LOG > $TESTS_REMAINING_LOG.tmp
-        mv $TESTS_REMAINING_LOG.tmp $TESTS_REMAINING_LOG
-        sync
-    fi
+
+    # the filename for the test and the name output are different.
+    # we don't include the tests/ directory in the name output.
+    seqnum=`echo $seq | sed -e "s;$SRC_DIR/;;"`
+
+    # Similarly, the result directory needs to replace the tests/
+    # part of the test location.
+    group=`dirname $seq`
+    export RESULT_DIR=`echo $group | sed -e "s;$SRC_DIR;$RESULT_BASE;"`
+    mkdir -p $RESULT_DIR
+    seqres="$RESULT_BASE/$seqnum"
+
+    echo -n "$seqnum"
 
     if $showme
     then
        echo
        continue
-    elif [ -f expunged ] && $expunge && egrep "^$seq([         ]|\$)" expunged >/dev/null
-    then
-       echo " - expunged"
-       rm -f $seq.out.bad
-       echo "/^$seq\$/d" >>$tmp.expunged
     elif [ ! -f $seq ]
     then
        echo " - no such test?"
-       echo "/^$seq\$/d" >>$tmp.expunged
     else
        # really going to try and run this one
        #
-       rm -f $seq.out.bad
-       lasttime=`sed -n -e "/^$seq /s/.* //p" <check.time`
+       rm -f $seqres.out.bad
+
+       # check if we really should run it
+       if [ -s $tmp.xlist ]; then
+               if grep $seqnum $tmp.xlist > /dev/null 2>&1 ; then
+                       echo "       [expunged]"
+                       continue
+               fi
+       fi
+
+       # slashes now in names, sed barfs on them so use grep
+       lasttime=`grep -w ^$seqnum $check.time | awk '// {print $2}'`
        if [ "X$lasttime" != X ]; then
                echo -n " ${lasttime}s ..."
        else
                echo -n "       "       # prettier output with timestamps.
        fi
-       rm -f core $seq.notrun
-
-       # for hangcheck ...
-       echo "$seq" >/tmp/check.sts
+       rm -f core $seqres.notrun
 
        start=`_wallclock`
        $timestamp && echo -n " ["`date "+%T"`"]"
        [ ! -x $seq ] && chmod u+x $seq # ensure we can run it
-       $LOGGER_PROG "run xfstest $seq"
+       $LOGGER_PROG "run xfstest $seqnum"
        ./$seq >$tmp.rawout 2>&1
        sts=$?
        $timestamp && _timestamp
@@ -564,16 +468,16 @@ do
        if [ -f core ]
        then
            echo -n " [dumped core]"
-           mv core $seq.core
+           mv core $RESULT_BASE/$seqnum.core
            err=true
        fi
 
-       if [ -f $seq.notrun ]
+       if [ -f $seqres.notrun ]
        then
            $timestamp || echo -n " [not run] "
-           $timestamp && echo " [not run]" && echo -n "        $seq -- "
-           cat $seq.notrun
-           notrun="$notrun $seq"
+           $timestamp && echo " [not run]" && echo -n "        $seqnum -- "
+           cat $seqres.notrun
+           notrun="$notrun $seqnum"
        else
            if [ $sts -ne 0 ]
            then
@@ -585,29 +489,33 @@ do
                echo " - no qualified output"
                err=true
            else
+
+               # coreutils 8.16+ changed quote formats in error messages from
+               # `foo' to 'foo'. Filter old versions to match the new version.
+               sed -i "s/\`/\'/g" $tmp.out
                if diff $seq.out $tmp.out >/dev/null 2>&1
                then
                    if $err
                    then
                        :
                    else
-                       echo "$seq `expr $stop - $start`" >>$tmp.time
+                       echo "$seqnum `expr $stop - $start`" >>$tmp.time
                        echo -n " `expr $stop - $start`s"
                    fi
                    echo ""
                else
-                   echo " - output mismatch (see $seq.out.bad)"
-                   mv $tmp.out $seq.out.bad
-                   $diff $seq.out $seq.out.bad | {
+                   echo " - output mismatch (see $seqres.out.bad)"
+                   mv $tmp.out $seqres.out.bad
+                   $diff $seq.out $seqres.out.bad | {
                        if test "$DIFF_LENGTH" -le 0; then
                                cat
                        else
                                head -n "$DIFF_LENGTH"
+                               echo "..."
+                               echo "(Run '$diff $seq.out $seqres.out.bad'" \
+                                       " to see the entire diff)"
                        fi; } | \
                        sed -e 's/^\(.\)/    \1/'
-                   echo "     ..."
-                   echo "     (Run '$diff $seq.out $seq.out.bad' to see the" \
-                        "entire diff)"
                    err=true
                fi
            fi
@@ -619,18 +527,18 @@ do
     #
     if $err
     then
-       bad="$bad $seq"
+       bad="$bad $seqnum"
        n_bad=`expr $n_bad + 1`
        quick=false
     fi
-    if [ ! -f $seq.notrun ]
+    if [ ! -f $seqres.notrun ]
     then
-       try="$try $seq"
+       try="$try $seqnum"
        n_try=`expr $n_try + 1`
         _check_test_fs
     fi
-    
-    seq="after_$seq"
+
+    seq="after_$seqnum"
 done
 
 interrupt=false